﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class CodeDoExpression : Expression
    {
        public CodeDoExpression() : base(OpCode.CodeDo)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            // not enough arguments on stack
            if (interpreterService.CodeStack.Count == 0)
                return;

            var expression = interpreterService.CodeStack.Pop();
            interpreterService.ExecStack.Push(expression);
        }
    }
}
